# -*- coding: utf-8 -*-
from hwm.plugin.base import BaseColectorPlugin

import subprocess
import re

class Disk(BaseColectorPlugin):

    def __init__(self, *args, **kargs):
        BaseColectorPlugin.__init__(self, *args, **kargs)
        self._period = 60 * 5
    
    @classmethod
    def description(class_):
        dct = BaseColectorPlugin.description()
        dct.update({
            'name': 'Disk collector',
            'slug': 'disk',
            'options': [
                (
                    '--mount-point',
                    {
                        'help': 'Specific the mount point',
                        'dest': 'mount_point'
                    }
                )
            ]
        })

        return dct

    def _prepare(self, **kargs):
        dbc = self.get_connector()
        cursor = dbc.cursor()

        try:
            cursor.execute(
                '''
CREATE TABLE IF NOT EXISTS storage(
    ID INTEGER PRIMARY KEY AUTOINCREMENT,
    MOUNT_POINT VARCHAR(300) NOT NULL,
    SIZE INTEGER NOT NULL DEFAULT 0,
    USED INTEGER NOT NULL DEFAULT 0,
    AVAIL INTEGER NOT NULL DEFAULT 0,
    COLECT_MOMENT TIMESTAMP DEFAULT CURRENT_TIMESTAMP
)
                '''
            )
        except Exception, e:
            print e
        else:
            try:
                cursor.execute(
                    '''
INSERT INTO storage(MOUNT_POINT, SIZE, USED, AVAIL) VALUES(:mount_point, :size, :used, :avail)
                    ''',
                    kargs
                )
            except Exception, e:
                print e
            else:
                dbc.commit()

        cursor.close()
        dbc.close()

    def do_colect(self):
        for line in subprocess.Popen(['/bin/df'], stdout=subprocess.PIPE).stdout:
            rst = re.match('^.+\s+(?P<size>[0-9]+)\s+(?P<used>[0-9]+)\s+(?P<avail>[0-9]+)\s+(?P<pct>[0-9]+)%\s+(?P<mount_point>(/([a-z]|0-9)+)+)$', line)
            if rst is not None and rst.groupdict().get('mount_point') == self._params.mount_point:
                self._prepare(**rst.groupdict())
                break